diretório PHP5-FPM / var / run / php5-fpm / não encontrado

1

Hoje reinicializei meu servidor e o PHP5-FPM falhou no início porque /var/run/php5-fpm/ não foi encontrado.

O /var/run/ é limpo na reinicialização e a maioria dos serviços recria seus diretórios /var/run/ na reinicialização, conforme visto neste pergunta SF . Eu sempre assumi que o PHP5-FPM criou o / var / run / php5-fpm / automaticamente quando reiniciado e as reinicializações anteriores não tiveram problemas.

O PHP5-FPM parou de criar o diretório em uma atualização ou nunca criou o diretório? Minha última reinicialização antes de hoje foi há mais de 30 dias e eu não precisei criar manualmente o diretório / var / run / php5-fpm / para isso ou qualquer reinicialização anterior.

Eu preciso adicionar o mkdir ao meu arquivo init.d para o php5-fpm, ou existe outra maneira recomendada? Além disso, por que esse erro "diretório não encontrado" não aconteceu antes?

Outras informações:

O servidor está executando o Debian 7 (Wheezy), Nginx e MySQL. /var/run está vinculado a /run/ . /run/ tem permissões de 755, de propriedade do root.

Obrigado.

arquivo PHP5-FPM em /etc/init.d/ contents

#!/bin/sh
### BEGIN INIT INFO
# Provides:          php-fpm php5-fpm
# Required-Start:    $remote_fs $network
# Required-Stop:     $remote_fs $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: starts php5-fpm
# Description:       Starts The PHP FastCGI Process Manager Daemon
### END INIT INFO

# Author: Ondrej Sury <[email protected]>

PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="PHP5 FastCGI Process Manager"
NAME=php5-fpm
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="--daemonize --fpm-config /etc/php5/fpm/php-fpm.conf"
PIDFILE=/var/run/php5-fpm.pid
TIMEOUT=30
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

# Don't run if we are running upstart
if init_is_upstart; then
    exit 1
fi

#
# Function to check the correctness of the config file
#
do_check()
{
    /usr/lib/php5/php5-fpm-checkconf || return 1
    return 0
}

#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
                || return 1
        start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
                $DAEMON_ARGS 2>/dev/null \
                || return 2
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --quiet --retry=QUIT/$TIMEOUT/TERM/5/KILL/5 --pidfile $PIDFILE --name $NAME
        RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        start-stop-daemon --stop --quiet --oknodo --retry=0/30/TERM/5/KILL/5 --exec $DAEMON
        [ "$?" = 2 ] && return 2
        # Many daemons don't delete their pidfiles when they exit.
        rm -f $PIDFILE
        return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        #
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        start-stop-daemon --stop --signal USR2 --quiet --pidfile $PIDFILE --name $NAME
        return 0
}

case "$1" in
    start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_check $VERBOSE
        case "$?" in
            0)
                do_start
                case "$?" in
                    0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                    2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
                esac
                ;;
            1) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
    stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
    status)
        status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
        ;;
    check)
        do_check yes
        ;;
    reload|force-reload)
        log_daemon_msg "Reloading $DESC" "$NAME"
        do_reload
        log_end_msg $?
        ;;
    reopen-logs)
        log_daemon_msg "Reopening $DESC logs" $NAME
        if start-stop-daemon --stop --signal USR1 --oknodo --quiet \
            --pidfile $PIDFILE --exec $DAEMON
        then
            log_end_msg 0
        else
            log_end_msg 1
        fi
        ;;
    restart)
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
    *)
        echo "Usage: $SCRIPTNAME {start|stop|status|restart|reload|force-reload}" >&2
        exit 1
    ;;
esac

:
    
por AnsonL 13.09.2013 / 17:08

3 respostas

0

Eu ainda não sei porque o PHP5-FPM parou de funcionar de repente, mas como o problema é que o PHP5-FPM não é capaz de criar diretórios em /var/run/ , uma solução é adicionar o comando

mkdir /var/run/php5-fpm/

para o arquivo /etc/init.d/php5-fpm na função do_start() .

Desta forma, quando o PHP5-FPM for iniciado, ele criará o diretório /var/run/php5-fpm/ .

Observação: /var/run está vinculado a /run/ , então /run/ pode funcionar no seu sistema também.

    
por 14.09.2013 / 15:37
1

Acho que depende de como isso é definido na sua configuração.

Na minha configuração do Debian eu não tenho esse diretório só tem um php5-fpm.pid em var / run

Mas eu tenho um soquete em / var / lib / php5-fpm em outras configurações que o soquete está em / tmp mas é porque eu o configurei lá, e não tenho o var / lib / php5-fpm

Então eu acho que você configura isso para criar soquete em / var / run / php5-fpm mas esse dir excluiu con reboot e php5-fpm não o cria por padrão (este é o meu caso, php5-fpm cria soquetes mas se o dir não existe php5-fpm não cria o socket e você precisa criar dir antes)

Portanto, verifique suas configurações e veja onde o soquete foi criado.

    
por 13.09.2013 / 17:32
0

Se eu tivesse que adivinhar a pasta deve ser criada manualmente e isso é um problema de permissões. Verifique se as permissões adequadas estão definidas para essa pasta.

    
por 13.09.2013 / 17:34